// DROTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DROTest.h"
#include "DROTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDROTestDlg dialog

CDROTestDlg::CDROTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDROTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDROTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDROTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDROTestDlg)
	DDX_Control(pDX, IDC_MACH1OCXCTRL1, m_Mach1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDROTestDlg, CDialog)
	//{{AFX_MSG_MAP(CDROTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_STARTENGINE, OnStartengine)
	ON_BN_CLICKED(IDC_ADDRESET, OnAddreset)
	ON_BN_CLICKED(IDC_ADDDRO, OnAdddro)
	ON_BN_CLICKED(IDC_SAVELAY, OnSavelay)
	ON_BN_CLICKED(IDC_LOADLAY, OnLoadlay)
	ON_BN_CLICKED(IDC_DELETELAY, OnDeletelay)
	ON_BN_CLICKED(IDC_ENC1999, OnEnc1999)
	ON_BN_CLICKED(IDC_SET2888, OnSet2888)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDROTestDlg message handlers

BOOL CDROTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	Running = false;    /// keep a variable to tell me if engine is running
	LoadDefaultLayout();  // load the default layout
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDROTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDROTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDROTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDROTestDlg::OnStartengine() 
{
  if( ! m_Mach1.InitEngine() )  // init the engines variables
   { MessageBox( "Problem initializing engine" );
     return; }
  if( ! m_Mach1.StartEngine() ) // start the main timer
     { MessageBox( "Problem starting engine" );
	   return;
	   }
  Running = true;
	
}

 

void CDROTestDlg::OnAddreset() 
{
  m_Mach1.AddEmergency( 10,10,50,20 );	 //add a reset button at x,y,width,height
}

void CDROTestDlg::OnAdddro() 
{
  m_Mach1.AddDRO( 30,30,150,25 );	  // same for a DRO
}

void CDROTestDlg::OnSavelay() 
{
   m_Mach1.SaveLayout();	  // save a layout
}

void CDROTestDlg::OnLoadlay() 
{
   CString Filename = "dialog";            // load a layout. If dialog is the file name
   BSTR file = Filename.AllocSysString();  // then you choose the file at run time
   m_Mach1.LoadLayout( &file );
   	
}

void CDROTestDlg::OnOK() 
{
    if( Running) m_Mach1.StopEngine();	 // stop the engine if running
	CDialog::OnOK();
}

void CDROTestDlg::LoadDefaultLayout()
{

   CString Filename = "default.lay";
   BSTR file = Filename.AllocSysString();  // since filename is not "dialog", this must be
   m_Mach1.LoadLayout( &file );            // the name of the file to load
   
}

void CDROTestDlg::OnDeletelay() 
{
  m_Mach1.DeleteLayout();	 // get rid of the layout
}

void CDROTestDlg::OnEnc1999() 
{
  m_Mach1.EncoderSetABSCount( 0, 999999 );	// set the absolute register on ENC1
}

void CDROTestDlg::OnSet2888() 
{
  m_Mach1.EncoderSetABSCount( 1, 888888 );  // set the abs reg on encoder 2
	
}
